import { IKeyboardInlineButton, IKeyboardButton } from "../../types/IKeyboard";
declare type DeepPartial<T> = T extends object ? {
    [P in keyof T]?: DeepPartial<T[P]>;
} : T;
export declare abstract class BaseButton {
    readonly text: string;
    constructor(text: string);
    abstract toObject(): Record<string, any>;
}
export declare class InlineButton extends BaseButton {
    readonly url: string;
    readonly payload: string;
    readonly switchQuery: string;
    readonly switchCurrentChatQuery: string;
    constructor(params: {
        text: string;
        url?: string;
        payload?: string;
        switchQuery?: string;
        switchCurrentChatQuery?: string;
    });
    toObject(): IKeyboardInlineButton;
}
export declare class Button extends BaseButton {
    private readonly params;
    readonly shareRequestId: number;
    constructor(text: string, params?: DeepPartial<IKeyboardButton>);
    toObject(): IKeyboardButton;
}
export {};
