"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = exports.InlineButton = exports.BaseButton = void 0;
const crypto_1 = require("crypto");
class BaseButton {
    constructor(text) {
        this.text = text;
    }
}
exports.BaseButton = BaseButton;
class InlineButton extends BaseButton {
    constructor(params) {
        super(params.text);
        for (let [key, val] of Object.entries(params)) {
            this[key] = val;
        }
    }
    toObject() {
        let btn = {
            text: this.text,
            callback_data: this.payload,
            url: this.url,
            switch_inline_query: this.switchQuery,
            switch_inline_query_current_chat: this.switchCurrentChatQuery,
        };
        return Object.entries(btn)
            .filter(([_, v]) => v != null)
            .reduce((acc, [key, val]) => (Object.assign({ [key]: val }, acc)), {});
    }
}
exports.InlineButton = InlineButton;
class Button extends BaseButton {
    constructor(text, params = {}) {
        super(text);
        this.params = params;
        this.shareRequestId = (0, crypto_1.randomInt)(-2147483648, 2147483647);
    }
    toObject() {
        var _a, _b, _c, _d;
        if (!this.params.text) {
            this.params.text = this.text;
        }
        if (((_a = this.params) === null || _a === void 0 ? void 0 : _a.request_chat) &&
            !((_b = this.params.request_chat) === null || _b === void 0 ? void 0 : _b.request_id)) {
            this.params.request_chat.request_id = this.shareRequestId;
        }
        else if (((_c = this.params) === null || _c === void 0 ? void 0 : _c.request_user) &&
            !((_d = this.params.request_user) === null || _d === void 0 ? void 0 : _d.request_id)) {
            this.params.request_user.request_id = this.shareRequestId;
        }
        return Object.assign({}, this.params);
    }
}
exports.Button = Button;
